﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;

namespace SimpleSample
{
    public class ChartSample : ContentPage
    {
		private StackLayout stack;
        public ChartSample()
        {
            stack = new StackLayout();
            
            var button = new Button();
            button.Clicked += button_Clicked;
            button.Text = "Export as PDF";
            stack.Children.Add(button);
          //  stack.Children.Add(GetChart());

            Content = stack;
        }

        void button_Clicked(object sender, EventArgs e)
        {
			SfChart chart1 = GetChart();
			chart1.HeightRequest = 700;
			chart1.WidthRequest = 500;
           
			var stream = new MemoryStream();
			var doc = new PdfDocument();
			doc.PageSettings.Margins.All = 0;
			var page = doc.Pages.Add();
			var g = page.Graphics;

			Stream imgStream = DependencyService.Get<IChartDependencyService>().GetImageStream(chart1);

			if(imgStream != null)
				g.DrawImage(PdfImage.FromStream(imgStream), 0, 0, 500, 700);

			doc.Save(stream);
			doc.Close(true);

			DependencyService.Get<IChartDependencyService>().ViewPDF(stream,"SfChart.pdf");
        }

        private SfChart chart;
        private SfChart GetChart()
        {
            chart = new SfChart
            {
                VerticalOptions = LayoutOptions.FillAndExpand,
                PrimaryAxis = new CategoryAxis { LabelPlacement = LabelPlacement.BetweenTicks },
                SecondaryAxis = new NumericalAxis()
            };

            chart.Series.Add(new ColumnSeries
            {
                DataMarker = new ChartDataMarker(),
                ItemsSource = GetDataPoints(),
                DataMarkerPosition = DataMarkerPosition.Center,
            });
            return chart;
        }

        private static List<ChartDataPoint> GetDataPoints()
        {
            return new List<ChartDataPoint>
            {
                new ChartDataPoint("A", 45),
                new ChartDataPoint("B", 54),
                new ChartDataPoint("C", 65),
                new ChartDataPoint("D", 23),
                new ChartDataPoint("E", 55),
            };
        }
    }
}
